/*********************************************************/
/*                                                       */
/* rexx:DNetGetFile.rexx  V1.0                           */
/*                                                       */
/* ARexx script for DNet's getfiles                      */
/*                                                       */
/* Requires rexxarplib.library V3.0                      */
/*                                                       */
/*  1991 Stefan Becker                                  */
/*                                                       */
/* ToolManager configuration file entry for this script: */
/*                                                       */
/* CLI:                                                  */
/* Alias    = Get File                                   */
/* RealName = rx DNetGetFile                             */
/* Path     = <path to DNet binaries>                    */
/* Args     = OFF                                        */
/* #                                                     */
/*                                                       */
/*********************************************************/

/* Set constants */
output='CON:0/0/640/100/Downloading File/AUTO/WAIT/ALT/INACTIVE'

/* Try to open rexxarplib */
IF ~SHOW('Libraries','rexxarplib.library') THEN
 IF ~ADDLIB('rexxarplib.library',0,-30,0) THEN RETURN 20

/* Put up a requester for the file name */
file=Request(50,50,'Specify file name','','Ok','Cancel','Workbench');

IF file=='' THEN
/* No file specified */
DO
 /* Print out an error message */
 IF OPEN(error,output,'Write') THEN
  DO
   WRITELN(error,'No file specified')
   WRITELN(error,'exiting...')
   CLOSE(error)
  END
END
/* Download file */
ELSE ADDRESS COMMAND 'getfiles >"'output'"' '"'file'"'

/* Exit script */
RETURN 0
