		/**************************************
		 *                                    *
		 *   AmigaDOS Handler for XPK files   *
		 *                                    *
		 *             Subroutines            *
		 *                                    *
		 **************************************/

	/* Includes */

#include "includes.h"
#include "defines.h"
#include "protos.h"

	/* Show error requester */

   BOOL
error_requester(BYTE *msg)
{
   BYTE *buffer;
   BOOL success = FALSE;

   /* Alloc buffer for structures */
   DEBUG1("   error_requester: msg=`%s'", msg);
   if (buffer = AllocMem(sizeof(struct Screen) +
			      4L * sizeof(struct IntuiText), MEMF_PUBLIC)) {
      struct Screen  *screen = (struct Screen *)buffer;

      /* Get data of workbench screen */
      if (GetScreenData((BYTE *)screen, (LONG)sizeof(struct Screen),
				  (LONG)WBENCHSCREEN, (LONG)NULL) == TRUE) {
	 STATIC struct TextAttr  topaz60_attr = { (STRPTR)"topaz.font",
				      TOPAZ_SIXTY, FS_NORMAL, FPF_ROMFONT },
			   topaz80_attr = { (STRPTR)"topaz.font",
				     TOPAZ_EIGHTY, FS_NORMAL, FPF_ROMFONT };
	 struct IntuiText  *itext_title = (struct IntuiText *)(screen + 1),
			   *itext_msg = itext_title + 1,
			   *itext_ok = itext_msg + 1,
			   *itext_cancel = itext_ok + 1;
	 USHORT border_left, border_top, width, height, max_width;

	 /* Calc border dimension of windows */
	 border_left = screen->WBorLeft;
	 border_top  = screen->BarHeight - screen->BarVBorder +
							    screen->WBorTop;
	 /* Init title text */
	 itext_title->LeftEdge  = border_left + 2 * 4;
	 itext_title->TopEdge   = border_top + 4;
	 itext_title->DrawMode  = JAM1;
	 itext_title->FrontPen  = 3;
	 itext_title->BackPen   = 0;
	 itext_title->ITextFont = &topaz60_attr;
	 itext_title->IText     = (UBYTE *)FindTask(NULL)->tc_Node.ln_Name;
	 itext_title->NextText  = itext_msg;
	 max_width              = IntuiTextLength(itext_title);

	 /* Init message text */
	 itext_msg->LeftEdge  = itext_title->LeftEdge;
	 itext_msg->TopEdge   = itext_title->TopEdge + 9 + 10;
	 itext_msg->DrawMode  = JAM1;
	 itext_msg->FrontPen  = 2;
	 itext_msg->BackPen   = 0;
	 itext_msg->ITextFont = &topaz80_attr;
	 itext_msg->IText     = (UBYTE *)msg;
	 itext_msg->NextText  = NULL;
	 if ((width = IntuiTextLength(itext_msg)) > max_width) {
	    max_width = width;
	 }

	 /* Init ok and cancel texts */
	 itext_ok->LeftEdge  = itext_cancel->LeftEdge  = 6;
	 itext_ok->TopEdge   = itext_cancel->TopEdge   = 4;
	 itext_ok->DrawMode  = itext_cancel->DrawMode  = JAM1;
	 itext_ok->FrontPen  = itext_cancel->FrontPen  = 3;
	 itext_ok->BackPen   = itext_cancel->BackPen   = 0;
	 itext_ok->ITextFont = itext_cancel->ITextFont = &topaz60_attr;
	 itext_ok->IText     = itext_cancel->IText     = (UBYTE *)"Ok";
	 itext_ok->NextText  = itext_cancel->NextText  = NULL;
	 if ((width = IntuiTextLength(itext_ok) +
		 IntuiTextLength(itext_cancel) + 2 * 16 + 40) > max_width) {
	    max_width = width;
	 }

	 /* Calc requester dimension and scale it if neccessary */
	 width = max_width + border_left + screen->WBorRight + 4 + 2 * 16;
	 if (width > screen->Width) {
	    width = screen->Width;
	 }
	 height = border_top + screen->WBorBottom + 9 + 10 + 8 + 10 + 9 +
							      2 * 8 + 2 * 4;
	 if (height > screen->Height) {
	    height = screen->Height;
	 }
	 AutoRequest((LONG)NULL, itext_title, itext_ok, itext_cancel, 0L,
					     0L, (LONG)width, (LONG)height);
      }
      FreeMem(buffer, sizeof(struct Screen) + 4L * sizeof(struct IntuiText));
   }
   DEBUG1("   error_requester: success=%d", success);
   return success;
}
	/* Start given process and return msg port opened by process */

   struct MsgPort *
create_process(struct MsgPort  *zombie_mp, VOID *code, BYTE *name, LONG data)
{
   struct ZombieMsg  *zm;
   struct MsgPort    *proc_mp = NULL;
   BPTR fh;

   /* Alloc zombie msg and open file handle for input/output */
   if (zm = AllocMem(sizeof(struct ZombieMsg), MEMF_PUBLIC)) {
      if (fh = Open("NIL:", (LONG)MODE_NEWFILE)) {
	 struct ProcessControlBlock  pcb_buffer, *pcb = &pcb_buffer;

	 /* Init reply port of zombie msg */
	 zm->zm_ExecMessage.mn_ReplyPort = zombie_mp;

	 /* Initialize process control block */
	 pcb->pcb_StackSize           = PROCESS_STACK_SIZE;
	 pcb->pcb_Pri                 = PROCESS_PRIORITY;
	 pcb->pcb_Control             = PRF_NOCLI | PRF_CODE;
	 pcb->pcb_TrapCode            = NULL;
	 pcb->pcb_Input               = fh;
	 pcb->pcb_Output              = fh;
	 pcb->pcb_Console.pcb_ConName = NULL;
	 pcb->pcb_LoadedCode          = (CPTR)code;
	 pcb->pcb_LastGasp            = zm;
	 pcb->pcb_WBProcess           = NULL;

	 /* Start process asyncronous */
	 if (ASyncRun(name, NULL, pcb) < 0L) {
	    error_requester("Can't start process");
	 } else {
	    struct HandshakeMsg  hm_buffer, *hm = &hm_buffer;

	    /* Init handshake msg with given data */
	    hm->hm_Message.mn_ReplyPort = zombie_mp;
	    hm->hm_Data                 = data;

	    /* Send handshake msg to new process */
	    PutMsg(pcb->pcb_WBProcess, &hm->hm_Message);
	    WaitPort(zombie_mp);
	    GetMsg(zombie_mp);

	    /* Get msg port from handshake msg */
	    if (!(proc_mp = (struct MsgPort *)hm->hm_Data)) {

	       /* Wait for zombie message */
	       WaitPort(zombie_mp);
	       GetMsg(zombie_mp);
	    }
	 }
      }

      /* If any error occured then don't forget to free zombie msg */
      if (!proc_mp) {
	 FreeMem(zm, sizeof(struct ZombieMsg));
      }
   }
   DEBUG3("    create_process: name=`%s' data=$%lx proc_mp=$%lx", name,
							     data, proc_mp);
   return proc_mp;
}
	/* Send AmigaDOS packet to given message port */

#asm
	XREF	_ArpBase
	XREF	_LVOSendPacket

	XDEF	_send_packet

_send_packet:
	move.l	4(sp),a1
	move.l	8(sp),d0
	lea.l	12(sp),a0

	pea	(a6)
	move.l	_ArpBase,a6
	jsr	_LVOSendPacket(a6)
	move.l	(sp)+,a6

	rts
#endasm
	/* Put AmigaDOS packet into given msg port and wait for its reply */

   VOID
put_packet(struct DosPacket  *dp, struct MsgPort  *mp, struct MsgPort  *rp)
{
   struct Message  *mn = dp->dp_Link;
   struct MsgPort  *old_rp = mn->mn_ReplyPort;

   /* Init reply port and send packet to given process */
   mn->mn_ReplyPort = rp;
   PutMsg(mp, mn);
   DEBUG3("    put_packet: sent: dp=$%lx mp=$%lx rp=$%lx", dp, mp, rp);

   /* Wait for reply of packet and restore reply port */
   WaitPort(rp);
   GetMsg(rp);
   DEBUG1("    put_packet: received: dp=$%lx", dp);
   mn->mn_ReplyPort = old_rp;
}
	/* Return given AmigaDOS packet to sender */

   VOID
return_packet(struct DosPacket  *dp, LONG res1, LONG res2)
{
   struct Process  *pr = (struct Process *)FindTask(NULL);
   struct MsgPort  *mp = dp->dp_Port;
   struct Message  *mn = dp->dp_Link;

   /* Init packet */
   dp->dp_Port = &pr->pr_MsgPort;
   dp->dp_Res1 = res1;
   dp->dp_Res2 = res2;
   DEBUG2("    return_packet: res1=%ld   res2=%ld", res1, res2);
   PutMsg(mp, mn);
}
	/* Build internal lock structure */

   LONG
build_internal_lock(struct PacketData  *pd, BPTR real_lock, LONG mode,
							     BPTR *lock_ptr)
{
   struct FileLock  *fl;
   BPTR lock = NULL;
   LONG error = 0L;

   /* Alloc and init internal lock */
   if (!(fl = DosAllocMem((LONG)sizeof(struct FileLock)))) {

      /* Don't forget to free real lock if any */
      if (real_lock) {
	 UnLock(real_lock);
      }
      error = ERROR_NO_FREE_STORE;
   } else {
      struct HandlerData  *hd = pd->pd_HandlerData;

      /* Init new internal lock */
      fl->fl_Key    = real_lock;
      fl->fl_Access = mode;
      fl->fl_Task   = &hd->hd_Process->pr_MsgPort;
      fl->fl_Volume = (BPTR)CTOB(hd->hd_VolumeNode);

      /* Link new lock into list */
      lock            = (BPTR)CTOB(fl);
      fl->fl_Link     = pd->pd_LockList;
      pd->pd_LockList = lock;
   }

   /* Finally save lock */
   *lock_ptr = lock;
   DEBUG2("    build_internal_lock: lock=$%lx   error=%ld", lock, error);
   return error;
}
	/* Check if given internal lock belongs to this handler */

   LONG
check_internal_lock(struct PacketData  *pd, BPTR lock)
{
   LONG error = 0L;

   /* First check for ZERO lock (root of this handler) */
   if (lock) {
      struct HandlerData  *hd = pd->pd_HandlerData;
      struct FileLock     *fl = (struct FileLock *)BTOC(lock);

      /* Now check fl_Task and fl_Volume */
      if (fl->fl_Task != &hd->hd_Process->pr_MsgPort ||
			   fl->fl_Volume != (BPTR)CTOB(hd->hd_VolumeNode)) {
	 error = ERROR_INVALID_LOCK;
      }
   }
   DEBUG2("    check_internal_lock: lock=$%lx   error=%ld", lock, error);
   return error;
}
	/* Get real path from given internal lock and object name */

   SHORT
get_real_path(struct PacketData  *pd, struct DosPacket  *dp, BPTR lock,
				    BSTR name, BYTE *buffer, USHORT max_len)
{
   BYTE  *name_ptr = (BYTE *)BTOC(name);
   SHORT name_len = (UBYTE)*name_ptr++, path_len = -1;

   /* Search start of real name according to current lock */
   DEBUG2("    get_real_path: name_len=%d   name=`%s'", name_len, name_ptr);
   if (name_len && !lock) {

      /* Skip AmigaDOS device name of this handler, e.g. `XPK:' */
      while (name_len-- && *name_ptr++ != ':');
   }

   /* Refuse if name too long */
   if (name_len <= max_len) {
      BPTR real_lock;

      /* Get path from lock to real filesystem */
      if (real_lock = get_real_lock(pd, lock)) {
	 path_len = PathName(real_lock, buffer, 100L);

	 /* Append name to real path */
	 if (name_len && (path_len + name_len + 1) <= max_len) {
	    BYTE *ptr = buffer + path_len;

	    /* First append delimiter */
	    if (path_len) {
	       BYTE c;

	       if ((c = *(ptr - 1)) != ':' && c != '/') {
		  *ptr++ = '/';
		  path_len++;
	       }
	    }

	    /* Now append name and EOS */
	    strncpy(ptr, name_ptr, (size_t)name_len);
	    path_len += name_len;
	    *(buffer + path_len) = '\0';
	 }
      }
   }
   DEBUG2("    get_real_path: path_len=%d buffer=`%s'",
				    path_len, (path_len > 0 ? buffer : ""));
   return path_len;
}
	/* Get real lock from given internal lock */

   BPTR
get_real_lock(struct PacketData  *pd, BPTR lock)
{
   BPTR real_lock;

   /* If no lock given then use lock to path from startup string */
   if (!lock) {
      real_lock = pd->pd_HandlerData->hd_PathLock;
   } else {
      struct FileLock  *fl = (struct FileLock *)BTOC(lock);

      /* Get real lock from fl_Key */
      real_lock = fl->fl_Key;
   }
   DEBUG3("    get_real_lock: lock=$%lx   real_lock=$%lx   mp=$%lx", lock,
		  real_lock, ((struct FileLock *)BTOC(real_lock))->fl_Task);
   return real_lock;
}
	/* Get message port of filesystem from given (real) file lock */

   struct MsgPort *
get_real_port(BPTR lock)
{
   struct MsgPort  *mp;

   if (!lock) {
      mp = NULL;
   } else {
      struct FileLock  *fl = (struct FileLock *)BTOC(lock);

      /* Get message port from fl_Task */
      mp = fl->fl_Task;
   }
   DEBUG2("    get_real_port: lock=$%lx   mp=$%lx", lock, mp);
   return mp;
}
	/* Build string with given text */

   BYTE *
build_string(BYTE *text)
{
   BYTE *ptr;
   LONG len = strlen(text);

   if (ptr = DosAllocMem(len + 1)) {
      strcpy(ptr, text);
   }
   return ptr;
}
	/* Build BSTR with given text */

   BSTR
build_bstring(BYTE *text)
{
   BYTE *ptr;
   LONG len = strlen(text);

   if (ptr = DosAllocMem(len + 1)) {
      *ptr = len;
      CopyMem(text, ptr + 1, len);
   }
   return (BSTR)CTOB(ptr);
}
	/* Create temporary file name from current date stamp */

   VOID
create_temp_name(BYTE *buffer)
{
   struct DateStamp  ds_buffer, *ds = &ds_buffer;

   /* Get current date stamp and place it into temp file name buffer */
   DateStamp(ds);
   SPrintf(buffer, TEMP_NAME_FORMAT, ds->ds_Days, ds->ds_Minute, ds->ds_Tick);
   DEBUG1("    create_temp_name: temp_name=`%s'", buffer);
}
	/* Glue routine for XprPack() due to trashed registers */

#asm
	XDEF	_xpk_pack
	XREF	_XpkBase

_xpk_pack:
	movem.l	d2-d7/a2-a6,-(sp)
	lea	11*4+4(sp),a0
	move.l	_XpkBase,a6
	jsr	-$2a(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
#endasm
	/* Glue routine for XprUnpack() due to trashed registers */

#asm
	XDEF	_xpk_unpack
	XREF	_XpkBase

_xpk_unpack:
	movem.l	d2-d7/a2-a6,-(sp)
	lea	11*4+4(sp),a0
	move.l	_XpkBase,a6
	jsr	-$30(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
#endasm
	/* Glue routine for XprExamine() due to trashed registers */

#asm
	XDEF	_xpk_examine
	XREF	_XpkBase

_xpk_examine:
	movem.l	d2-d7/a2-a6,-(sp)
	move.l	11*4+4(sp),a0
	lea	12*4+4(sp),a1
	move.l	_XpkBase,a6
	jsr	-$24(a6)
	movem.l	(sp)+,d2-d7/a2-a6
	rts
#endasm
